library dllgui;

{$mode objfpc}{$H+}

uses
  Classes,
  Interfaces, Forms, dllguiunit1, fndllgui
  { you can add units after this };

procedure CreateForm(var OwnerForm: TForm; IsModal: Boolean);
begin
  // Creating dll form.
  If Not Assigned(GuiForm1) then
  begin
    GuiForm1:= TGuiForm1.Create(OwnerForm);
  end;

  // Assingnig Dll Gui Functions object properties.
  OFnDllGui.Owner:= OwnerForm; // The main form passed as a parameter.
  OFnDllGui.OwnerEnabled:= TForm(OwnerForm).Enabled; // The original main form enabled property.
  GuiForm1.IsModal:= IsModal; // The mode passed as parameter to be assigned to dll form.
  if IsModal then
  begin
    OFnDllGui.Owner.Enabled:= False;
  end;
  GuiForm1.Show;
end;

procedure DestroyForm();
begin
  If (Assigned(GuiForm1)) then
  begin
    GuiForm1.Close;
    OFnDllGui.RestoreOwnerEnabled(); // Restore original main form enabled property.
    GuiForm1.Free;
    GuiForm1:= nil;
  end;
end;

{$R *.res}

exports
  CreateForm,
  DestroyForm;

initialization

OFnDllGui:= TFnDllGui.Create; // Creating Dll Gui Functions object.
Application.Initialize;
end.

finalization

OFnDllGui.Free; // Destroy Dll Gui Functions object.
OFnDllGui:= nil;
Application.Terminate;
end.

begin
end.

