unit dllguiunit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, fndllgui;

type

  { TForm2 }

  { TGuiForm2 }

  TGuiForm2 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    IsModal: Boolean; // Required for postmodal function.
  end; 

var
  GuiForm2: TGuiForm2;

implementation

{$R *.lfm}

{ TForm2 }

// This is a sample of creating a message box from another dll form.
// A message box must be trated as a modal form.
procedure TGuiForm2.Button1Click(Sender: TObject);
begin
  OFnDllGui.PreModal();
  ShowMessage(Label1.Caption);
  OFnDllGui.PostModal(Self.IsModal);
end;

// Close function. Deleting forms created from this form and
// restoring enabled property of main form.
procedure TGuiForm2.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  OFnDllGui.RestoreOwnerEnabled();
end;

procedure TGuiForm2.FormShow(Sender: TObject);
begin
  If IsModal then begin
    Label1.Caption:= 'Hello, I''m a MODAL window from Dll';
  end
  else
  begin
    Label1.Caption:= 'Hello, I''m a NO MODAL window from Dll';
  end;
end;

end.

