unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DynLibs;

type

  TCreateForm = procedure(var OwnerForm: TForm; IsModal: Boolean);
  TDestroyForm = procedure();

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
    LibGui: TLibHandle;
    CreateForm: TCreateForm;
    DestroyForm: TDestroyForm;
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  LibGui:= LoadLibrary('dllgui');
  CreateForm:= TCreateForm(GetProcAddress(LibGui, 'CreateForm'));
  DestroyForm:= TDestroyForm(GetProcAddress(LibGui, 'DestroyForm'));
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  CreateForm(Self, CheckBox1.Checked);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DestroyForm();
  FreeLibrary(LibGui);
end;

end.

